module hpsfreq(
input    clk,
input    chipselect,
input    write,
input [7:0] writedata,
output [32:0] op
);

// 8bit input from HPS
logic [7:0] f_calc = 8'b00001111 ;

// 20 bit counter. 12LSBs are set to 1. 8 MSBs are f_calc
// this allows us to make a clk with op ranging from
logic [19:0] cntr_f = 0000_0000_0000_0000_0000; 
logic op_val = 0;

always_ff @(posedge clk) begin
    if (chipselect && write)
        f_calc <=writedata;
end

always_ff @(posedge clk) begin // 50MHz clk in
    if ( cntr_f < ({ f_calc, {12{1'b1}} }) ) 
        cntr_f <= cntr_f + 1;
    
    else begin
        cntr_f <= {{8{1'b0}}, {12{1'b0}}};
        op_val <= ~op_val;
    end

    if (op_val)
        op <= { 1, {22{1'b1}}, 0, {9{1'b0}}}; //MSB FIRST  In 2's complement: +2^23 - 1
    else
        op <= { 1, {22{1'b0}}, 1, {9{1'b0}}}; //MSB FIRST  In 2's complement: -2^23 + 1, 33 bits wide
end

endmodule
