`timescale 1ns/1ns
module testbench();


logic clk=1'b0;
logic chipselect;
logic write;
logic bclk=1'b0;
logic [15:0] address = 0;
logic [15:0] data = -24000;
logic [32:0] out;
logic [27:0] counter = 0;



parameter DIV = 1042;
always	#10 clk = ~clk;

always @(posedge clk) begin 
	if( (counter >= 28'd1042-1)) begin 
		counter <= 0;
	end
	else
		counter <= counter +1;
    bclk <= (counter < 28'd521 ) ? 1'b0 : 1'b1;
end


	

hpsfreq h1 (.clk(clk),
	    .chipselect(chipselect),
	    .write(write),
	    .bclk(bclk),
            .addr(address),
            .writedata(data),
	    .op(out)
);

int i;

initial begin 
	for ( i = 0 ; i <48000 ; i=i+1) begin 
		@(posedge clk); address = address + 1; data = 23999 - i;
	end 
end

initial begin 

		write = 0; chipselect = 0;
	#5 	write = 1; chipselect = 1;
	#980000 write = 0; chipselect = 0;
	#1000000000 $finish();
end

endmodule
